SystemOrganization addCategory: #'DialogItemsChooser-Core'!
SystemOrganization addCategory: #'DialogItemsChooser-UI'!

DialogWindow subclass: #DialogItemsChooserUI
	instanceVariableNames: 'dialogItemsChooser selectedItems selectedItemsModel unselectedItems unselectedItemsModel unselectedItemsSearchingString selectedItemsSearchingString unselectedItemsTextArea selectedItemsTextArea unselectedSelection selectedSelectionIndex selectedSelectionList unselectedSelectionList unselectedSelectionIndex selectedItemsList'
	classVariableNames: 'AlreadySearchedSelectedItemsList AlreadySearchedUnselectedItemsList'
	poolDictionaries: ''
	category: 'DialogItemsChooser-UI'!

DialogItemsChooserUI class
	instanceVariableNames: 'alreadySearchedSelectedItemsListMaxSize alreadySearchedUnselectedItemsListMaxSize'!

!DialogItemsChooserUI commentStamp: 'BenjaminVanRyseghem 9/17/2010 00:20' prior: 0!
unselectedItems is the original list to search in

selectItems is the list of the selected items!

DialogItemsChooserUI class
	instanceVariableNames: 'alreadySearchedSelectedItemsListMaxSize alreadySearchedUnselectedItemsListMaxSize'!

!DialogItemsChooserUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:25'!
alreadySearchedSelectedItemsListMaxSize

	^ alreadySearchedSelectedItemsListMaxSize! !

!DialogItemsChooserUI class methodsFor: 'accessing' stamp: 'bvr 9/19/2010 19:16'!
alreadySearchedSelectedItemsListMaxSize: anObject
	anObject ifNil: [^self].
	alreadySearchedSelectedItemsListMaxSize := anObject.
	self allInstancesDo: [:each | each alreadySearchedSelectedItemsListMaxSize: anObject]! !

!DialogItemsChooserUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:25'!
alreadySearchedUnselectedItemsListMaxSize

	^ alreadySearchedUnselectedItemsListMaxSize! !

!DialogItemsChooserUI class methodsFor: 'accessing' stamp: 'bvr 9/19/2010 19:16'!
alreadySearchedUnselectedItemsListMaxSize: anObject
	anObject ifNil: [^self].
	alreadySearchedUnselectedItemsListMaxSize := anObject.
	self allInstancesDo: [:each | each alreadySearchedUnselectedItemsListMaxSize: anObject]! !

!DialogItemsChooserUI class methodsFor: 'settings' stamp: 'bvr 9/19/2010 19:24'!
dialogItemsChooserSettingsOn: aBuilder
	<systemsettings>
		(aBuilder group: #dialogItemsChooser)
		target: self;
		label: 'Items Chooser Dialog Window' translated;
		parent: #morphic;
		description: 'Settings related to the Items Chooser Dialog Window' translated;
			with: [
				(aBuilder setting: #alreadySearchedUnselectedItemsListMaxSize)
				label: 'Size of the Unselected Items History' translated.
				(aBuilder setting: #alreadySearchedSelectedItemsListMaxSize)
				label: 'Size of the Selected Items History' translated.]! !

!DialogItemsChooserUI class methodsFor: 'initialize-release' stamp: 'bvr 9/19/2010 19:23'!
initialize
	super initialize.
	alreadySearchedUnselectedItemsListMaxSize := 15.
	alreadySearchedSelectedItemsListMaxSize := 15! !

!DialogItemsChooserUI class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/18/2010 17:21'!
on: aDialogItemsChooser
	^self basicNew 
		unselectedItems: aDialogItemsChooser unselectedItems;
		selectedItems: aDialogItemsChooser selectedItems;
		dialogItemsChooser: aDialogItemsChooser;
		initialize.! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllButtonAction
	self addAllItems.! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllButtonLabel
	^'>>'! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addAllButtonState
	^false! !

!DialogItemsChooserUI methodsFor: 'buttons behavior' stamp: 'GaryChambers 2/11/2011 14:08'!
addAllItems

	| selection |
	selection := self unselectedItemsProbablyRestricted.
	selection ifEmpty: [^self].
	self unselectedItems removeAll: selection.
	self selectedItems addAll: selection.
	unselectedSelectionList removeAll.
	self unselectedSelectionIndex: 0.
	self
		changed: #selectedItemsProbablyRestricted;
		changed: #hasSelectedItems;
		changed: #unselectedItemsProbablyRestricted;
		changed: #hasUnselectedItems;
		changed: #hasUnselectedSelections! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addButtonAction
	self addSelectedItems.! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addButtonLabel
	^'>'! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
addButtonState
	^false! !

!DialogItemsChooserUI methodsFor: 'buttons behavior' stamp: 'GaryChambers 2/11/2011 14:09'!
addSelectedItems

	| selection |
	selection := self unselectedSelectionItems.
	selection ifEmpty: [^self].
	self unselectedItems removeAll: selection.
	self selectedItems addAll: selection.
	unselectedSelectionList removeAll.
	self unselectedSelectionIndex: 0.
	self
		changed: #selectedItemsProbablyRestricted;
		changed: #hasSelectedItems;
		changed: #unselectedItemsProbablyRestricted;
		changed: #hasUnselectedItems;
		changed: #hasUnselectedSelections! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:43'!
addToAlreadySearchedSelectedItemsList: aString
	self alreadySearchedSelectedItemsList size = self alreadySearchedSelectedItemsListMaxSize
		ifTrue: [self alreadySearchedSelectedItemsList removeLast ].
	self alreadySearchedSelectedItemsList addFirst: aString! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:43'!
addToAlreadySearchedUnselectedItemsList: aString
	self alreadySearchedUnselectedItemsList size = self alreadySearchedUnselectedItemsListMaxSize
		ifTrue: [self alreadySearchedUnselectedItemsList removeLast ].
	self alreadySearchedUnselectedItemsList addFirst: aString! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:21'!
alreadySearchedSelectedItemsList
	^AlreadySearchedSelectedItemsList ifNil: [AlreadySearchedSelectedItemsList := OrderedCollection new]! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:24'!
alreadySearchedSelectedItemsListMaxSize
	^self class alreadySearchedSelectedItemsListMaxSize! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:41'!
alreadySearchedSelectedItemsListMaxSize: anInteger

	[self alreadySearchedSelectedItemsList size > anInteger]
		whileTrue: [self alreadySearchedSelectedItemsList removeLast]! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 15:51'!
alreadySearchedUnselectedItemsList
	^AlreadySearchedUnselectedItemsList ifNil: [AlreadySearchedUnselectedItemsList := OrderedCollection new]! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:42'!
alreadySearchedUnselectedItemsListMaxSize
	^self class alreadySearchedUnselectedItemsListMaxSize! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:42'!
alreadySearchedUnselectedItemsListMaxSize: anInteger

	[self alreadySearchedUnselectedItemsList size > anInteger]
		whileTrue: [self alreadySearchedUnselectedItemsList removeLast]! !

!DialogItemsChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/16/2010 20:51'!
applyChanges
	self valid! !

!DialogItemsChooserUI methodsFor: 'build items' stamp: 'GaryChambers 2/11/2011 14:04'!
buildAddAllButton
	"Answer a new button for removing all items
	form the unslected list and adding to the selected list."
	
	^(self
		newButtonFor: self
		getState: #addAllButtonState
		action: #addAllButtonAction 
		arguments: nil
		getEnabled: #hasUnselectedItems
		getLabel: #addAllButtonLabel
		help: nil)
		hResizing: #spaceFill! !

!DialogItemsChooserUI methodsFor: 'build items' stamp: 'GaryChambers 2/11/2011 14:04'!
buildAddButton
	"Answer a new button for removing selected items
	from the unselected list and adding to the selected list."
	
	^(self
		newButtonFor: self
		getState: #addButtonState
		action: #addButtonAction 
		arguments: nil
		getEnabled: #hasUnselectedSelections
		getLabel: #addButtonLabel
		help: nil)
		hResizing: #spaceFill! !

!DialogItemsChooserUI methodsFor: 'build items' stamp: 'GaryChambers 2/11/2011 14:05'!
buildRemoveAllButton
	"Answer a new button for removing all items from the
	selected list and adding to the unselected list."
	
	^(self
		newButtonFor: self
		getState: #removeAllButtonState
		action: #removeAllButtonAction
		arguments: nil
		getEnabled: #hasSelectedItems
		getLabel: #removeAllButtonLabel
		help: nil)
		hResizing: #spaceFill! !

!DialogItemsChooserUI methodsFor: 'build items' stamp: 'GaryChambers 2/11/2011 14:04'!
buildRemoveButton
	"Answer a new button for removing selected items
	from the selected list and adding to the unselected list."
	
	^(self
		newButtonFor: self
		getState: #removeButtonState
		action: #removeButtonAction 
		arguments: nil
		getEnabled: #hasSelectedSelections
		getLabel: #removeButtonLabel
		help: nil)
		hResizing: #spaceFill! !

!DialogItemsChooserUI methodsFor: 'build items' stamp: 'CamilloBruni 9/12/2011 14:49'!
buildSelectedItemsList

	^selectedItemsList := (PluggableListMorph
		on: self 
		list: #selectedItemsProbablyRestricted 
		primarySelection: #selectedSelectionIndex
		changePrimarySelection: #selectedSelectionIndex:
		listSelection: #selectedSelectionAt:
		changeListSelection: #selectedSelectionAt:put:
		menu: nil)
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!DialogItemsChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 12/3/2010 10:06'!
buildSelectedItemsSearchingTextArea: aWindow

	^aWindow
		newAutoAcceptTextEntryFor: self
		get: #selectedItemsSearchingString
		set: #selectedItemsSearchingString:
		class: String
		getEnabled: nil
		help: 'Enter the name of a package' translated! !

!DialogItemsChooserUI methodsFor: 'build items' stamp: 'CamilloBruni 9/12/2011 14:49'!
buildUnselectedItemsList

	^(PluggableListMorph
		on: self 
		list: #unselectedItemsProbablyRestricted 
		primarySelection: #unselectedSelectionIndex
		changePrimarySelection: #unselectedSelectionIndex:
		listSelection: #unselectedSelectionAt:
		changeListSelection: #unselectedSelectionAt:put:
		menu: nil)
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!DialogItemsChooserUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 12/3/2010 10:05'!
buildUnselectedItemsSearchingTextArea: aWindow

	^aWindow
		newAutoAcceptTextEntryFor: self
		get: #unselectedItemsSearchingString
		set: #unselectedItemsSearchingString:
		class: String
		getEnabled: nil
		help: 'Enter the name of a package' translated! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
cancelButtonLabel
	^'Cancel'! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
cancelButtonState
	^false! !

!DialogItemsChooserUI methodsFor: 'display' stamp: 'GaryChambers 7/5/2011 09:29'!
centering
	self left: ((World width / 2) - (self width /2)) rounded.
	self top: ((World height / 2) - (self height /2)) rounded! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 17:16'!
dialogItemsChooser
	^ dialogItemsChooser! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 17:16'!
dialogItemsChooser: aDialogItemsChooser
	dialogItemsChooser := aDialogItemsChooser! !

!DialogItemsChooserUI methodsFor: 'selectedList' stamp: 'GaryChambers 2/11/2011 13:54'!
hasSelectedItems
	"Answer whether the selected list has items."

	^self selectedItems notEmpty! !

!DialogItemsChooserUI methodsFor: 'selectedList' stamp: 'GaryChambers 2/11/2011 13:58'!
hasSelectedSelections
	"Answer whether the selected list has selected items."

	^selectedSelectionList anySatisfy: [:selected | selected]! !

!DialogItemsChooserUI methodsFor: 'unselectedList' stamp: 'GaryChambers 2/11/2011 13:47'!
hasUnselectedItems
	"Answer whether the unselected list has items."

	^self unselectedItems notEmpty! !

!DialogItemsChooserUI methodsFor: 'unselectedList' stamp: 'GaryChambers 2/11/2011 13:58'!
hasUnselectedSelections
	"Answer whether the unselected list has selected items."

	^unselectedSelectionList anySatisfy: [:selected | selected]! !

!DialogItemsChooserUI methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 12/2/2010 18:14'!
initialize

	unselectedItemsSearchingString := String new.
	selectedItemsSearchingString := String new.
	selectedSelectionList := Dictionary new.
	unselectedSelectionList := Dictionary new.
	
	super initialize.
	
	self vResizing: #shrinkWrap.
	self hResizing: #shrinkWrap.! !

!DialogItemsChooserUI methodsFor: 'display' stamp: 'bvr 9/19/2010 19:32'!
isResizeable
	^true! !

!DialogItemsChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
msgPaneMenu: aMenu shifted: shifted
	^ aMenu labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
explore it (I)
debug it
accept (s)
cancel (l)
implementors (m)
methods containing (E)
senders (n)' 
		lines: #(0 3 5 9 14)
		selections: #(find findAgain setSearchString again undo copySelection cut paste pasteRecent doIt printIt inspectIt exploreIt debugIt accept cancel implementorsOfIt methodSourceContainingIt sendersOfIt)! !

!DialogItemsChooserUI methodsFor: 'display' stamp: 'GaryChambers 2/11/2011 13:52'!
newContentMorph
	| trees unselectedItemsCol selectedItemsCol buttons |
	buttons := (self newGroupboxFor: (
		(self newColumn: {
			self buildAddAllButton.
			self buildAddButton.
			self buildRemoveButton.
			self buildRemoveAllButton})
			vResizing: #shrinkWrap))
		vResizing: #shrinkWrap.
	
	unselectedItemsCol := self newGroupbox: self unselectedLabel for: (self newColumn: {
							self buildUnselectedItemsSearchingTextArea: self.
							self buildUnselectedItemsList.}).
	selectedItemsCol := self newGroupbox: self selectedLabel for: (self newColumn: {
							self buildSelectedItemsSearchingTextArea: self.
							self buildSelectedItemsList.}).
	trees := self newRow: {
					unselectedItemsCol.
					"self newGroupboxFor: self buildUnselectedItemsTree."
					buttons hResizing: #shrinkWrap.
					selectedItemsCol}.
	^trees vResizing: #spaceFill.
! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
okButtonAction
	self valid.! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
okButtonLabel
	^'Ok'! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
okButtonState
	^false! !

!DialogItemsChooserUI methodsFor: 'display' stamp: 'bvr 9/19/2010 19:28'!
openInWorld
	super openInWorld.
	self width: 500.
	self height: 400.
	self centering
! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeAllButtonAction
	self removeAllItems.! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeAllButtonLabel
	^'<<'! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeAllButtonState
	^false! !

!DialogItemsChooserUI methodsFor: 'buttons behavior' stamp: 'GaryChambers 2/11/2011 14:09'!
removeAllItems

	| selection |
	selection := self selectedItemsProbablyRestricted.
	selection ifEmpty: [^self].
	self selectedItems removeAll: selection.
	self unselectedItems addAll: selection.
	selectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItemsProbablyRestricted;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItemsProbablyRestricted;
		changed: #hasUnselectedItems! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeButtonAction
	self removeSelectedItems.! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeButtonLabel
	^'<'! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
removeButtonState
	^false! !

!DialogItemsChooserUI methodsFor: 'buttons behavior' stamp: 'GaryChambers 2/11/2011 14:09'!
removeSelectedItems

	| selection |
	selection := self selectedSelectionItems.
	selection ifEmpty: [^self].
	self selectedItems removeAll: selection.
	self unselectedItems addAll: selection.
	selectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItemsProbablyRestricted;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItemsProbablyRestricted;
		changed: #hasUnselectedItems! !

!DialogItemsChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/18/2010 16:49'!
roots: aTree
	aTree == unselectedItemsModel
		ifTrue: [ ^ self unselectedItemsProbablyRestricted].
	aTree == selectedItemsModel
		ifTrue:[ ^ self selectedItemsProbablyRestricted].! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchButtonLabel
	^'Search'! !

!DialogItemsChooserUI methodsFor: 'buttons creations' stamp: 'BenjaminVanRyseghem 8/30/2010 3:44'!
searchButtonState
	^false! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 14:10'!
selectedItems
	^ selectedItems! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 00:53'!
selectedItems: aList
	selectedItems := aList.! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/16/2010 23:49'!
selectedItemsModel

	^ selectedItemsModel! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/16/2010 23:49'!
selectedItemsModel: anObject

	selectedItemsModel := anObject! !

!DialogItemsChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 12/1/2010 15:25'!
selectedItemsProbablyRestricted

	| matcher string |
	string := self selectedItemsSearchingString.
	matcher := string
					ifEmpty: ['*']
					ifNotEmpty: [
						(string last = $*) 
							ifTrue: [string]
							ifFalse:[string, '*']].
	^self selectedItems select: [:each | matcher match: each].! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:44'!
selectedItemsSearchingString

	^ selectedItemsSearchingString! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'GaryChambers 2/11/2011 14:12'!
selectedItemsSearchingString: anObject

	selectedItemsSearchingString := anObject.
	selectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItemsProbablyRestricted;
		changed: #selectedSelectionAt:;
		changed: #selectedSelectionIndex;
		changed: #hasSelectedSelections! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:46'!
selectedItemsTextArea

	^ selectedItemsTextArea! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 16:46'!
selectedItemsTextArea: anObject

	selectedItemsTextArea := anObject! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 17:22'!
selectedLabel
	^self dialogItemsChooser isNil
		ifTrue: ['Selected Items' translated]
		ifFalse: [self dialogItemsChooser selectedLabel]! !

!DialogItemsChooserUI methodsFor: 'selectedList' stamp: 'BenjaminVanRyseghem 12/2/2010 17:50'!
selectedSelectionAt: index

	^selectedSelectionList at: index ifAbsent: [false]! !

!DialogItemsChooserUI methodsFor: 'selectedList' stamp: 'GaryChambers 2/11/2011 14:00'!
selectedSelectionAt: index put: aBoolean
	"Mark the item as selected or not."
	
	selectedSelectionList at: index put: aBoolean.
	self changed: #hasSelectedSelections! !

!DialogItemsChooserUI methodsFor: 'selectedList' stamp: 'BenjaminVanRyseghem 12/2/2010 17:34'!
selectedSelectionIndex
	selectedSelectionIndex ifNil: [selectedSelectionIndex := 0].
	^selectedSelectionIndex! !

!DialogItemsChooserUI methodsFor: 'selectedList' stamp: 'BenjaminVanRyseghem 12/2/2010 17:34'!
selectedSelectionIndex: anObject

	selectedSelectionIndex := anObject.
	self changed: #selectedSelectionIndex! !

!DialogItemsChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 12/2/2010 18:20'!
selectedSelectionItems

	| result |
	result := OrderedCollection new.
	self selectedItemsProbablyRestricted doWithIndex: [:item :index |
		(self selectedSelectionAt: index)
			ifTrue: [result add: item]].
	^result! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 00:43'!
unselectedItems
	^unselectedItems! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 00:52'!
unselectedItems: anOrderedCollection 
	
	unselectedItems := anOrderedCollection.! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 14:16'!
unselectedItemsModel

	^ unselectedItemsModel! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 14:16'!
unselectedItemsModel: anObject

	unselectedItemsModel := anObject! !

!DialogItemsChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 12/1/2010 15:16'!
unselectedItemsProbablyRestricted

	| matcher string |
	string := self unselectedItemsSearchingString.
	matcher := string
					ifEmpty: ['*']
					ifNotEmpty: [
						(string last = $*) 
							ifTrue: [string]
							ifFalse:[string, '*']].
	^self unselectedItems select: [:each | matcher match: each].! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 14:31'!
unselectedItemsSearchingString

	^ unselectedItemsSearchingString! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'GaryChambers 2/11/2011 14:11'!
unselectedItemsSearchingString: anObject

	unselectedItemsSearchingString := anObject.
	unselectedSelectionList removeAll.
	self unselectedSelectionIndex: 0.
	self
		changed: #unselectedItemsProbablyRestricted;
		changed: #unselectedSelectionAt:;
		changed: #unselectedSelectionIndex;
		changed: #hasUnselectedSelections! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 15:36'!
unselectedItemsTextArea
	^unselectedItemsTextArea! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 15:35'!
unselectedItemsTextArea: anObject

	unselectedItemsTextArea := anObject! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 17:20'!
unselectedLabel
	^self dialogItemsChooser isNil
		ifTrue: ['Unselected Items' translated]
		ifFalse: [self dialogItemsChooser unselectedLabel]! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/1/2010 15:52'!
unselectedSelection
	unselectedSelection ifNil: [unselectedSelection := 0].
	^unselectedSelection! !

!DialogItemsChooserUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/1/2010 15:44'!
unselectedSelection: anObject

	unselectedSelection := anObject! !

!DialogItemsChooserUI methodsFor: 'unselectedList' stamp: 'BenjaminVanRyseghem 12/2/2010 17:52'!
unselectedSelectionAt: index

	^unselectedSelectionList at: index ifAbsent: [false]! !

!DialogItemsChooserUI methodsFor: 'unselectedList' stamp: 'BenjaminVanRyseghem 12/2/2010 17:52'!
unselectedSelectionAt: index Put: anObject
	unselectedSelectionList at: index put: anObject! !

!DialogItemsChooserUI methodsFor: 'unselectedList' stamp: 'GaryChambers 2/11/2011 14:00'!
unselectedSelectionAt: index put: aBoolean
	"Mark the item as selected or not."
	
	unselectedSelectionList at: index put: aBoolean.
	self changed: #hasUnselectedSelections! !

!DialogItemsChooserUI methodsFor: 'unselectedList' stamp: 'BenjaminVanRyseghem 12/2/2010 17:52'!
unselectedSelectionIndex
	unselectedSelectionIndex ifNil: [unselectedSelectionIndex := 0].
	^unselectedSelectionIndex! !

!DialogItemsChooserUI methodsFor: 'unselectedList' stamp: 'BenjaminVanRyseghem 12/2/2010 17:52'!
unselectedSelectionIndex: anObject

	unselectedSelectionIndex := anObject.
	self changed: #unselectedSelectionIndex! !

!DialogItemsChooserUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 12/2/2010 18:20'!
unselectedSelectionItems

	| result |
	result := OrderedCollection new.
	self unselectedItemsProbablyRestricted doWithIndex: [:item :index |
		(self unselectedSelectionAt: index)
			ifTrue: [result add: item]].
	^result! !

!DialogItemsChooserUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/18/2010 17:17'!
valid
	self dialogItemsChooser sendSelection! !

Object subclass: #DialogItemsChooser
	instanceVariableNames: 'methodNameUI choicesList selection unselectedItems selectedItems resultList model title selectedItemsSetterSelector unselectedLabel selectedLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DialogItemsChooser-Core'!

!DialogItemsChooser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/18/2010 17:15'!
on: aModel unselectedItems: unselectedItems selectedItems: selectedItems selectedItemsSetterSelector: anotherSelector title: aString unselectedItemsLabel: unselectedLabel selectedItemsLabel: selectedLabel
	| instance |
	instance := self new 
					model: aModel;
					unselectedItems: unselectedItems;
					selectedItems: selectedItems;
					selectedItemsSetterSelector: anotherSelector;
					title: aString;
					unselectedLabel: unselectedLabel;
					selectedLabel: selectedLabel.
	^instance.! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/16/2010 20:56'!
choicesList
	choicesList isNil
		ifTrue: [choicesList := OrderedCollection new].
	^choicesList! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:27'!
choicesList: anObject

	choicesList := anObject! !

!DialogItemsChooser methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 9/16/2010 00:26'!
initialize
	super initialize.
	selection := OrderedCollection new.! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:27'!
methodNameUI

	^ methodNameUI! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:27'!
methodNameUI: anObject

	methodNameUI := anObject! !

!DialogItemsChooser methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 9/17/2010 02:02'!
model
	^model! !

!DialogItemsChooser methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 9/17/2010 02:02'!
model: aModel
	model := aModel! !

!DialogItemsChooser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 9/17/2010 02:42'!
openInWorld

	(self uiClass on: self)
			title: self title;
			openInWorld! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/16/2010 21:02'!
resultList
	^ resultList! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/16/2010 21:03'!
resultList: aList
	resultList := aList! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:27'!
selectedItems

	^ selectedItems! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:27'!
selectedItems: anObject

	selectedItems := anObject! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:13'!
selectedItemsSetterSelector
	^selectedItemsSetterSelector! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:14'!
selectedItemsSetterSelector: aSelector
	selectedItemsSetterSelector := aSelector! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 17:04'!
selectedLabel
	^selectedLabel! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 17:04'!
selectedLabel: anObject

	selectedLabel := anObject! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:12'!
selection
	^selection! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:31'!
sendSelection
	self model perform: self selectedItemsSetterSelector with: self selectedItems! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/16/2010 22:04'!
title
		^title! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/16/2010 22:04'!
title: aFinderUI
	title := aFinderUI! !

!DialogItemsChooser methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 9/18/2010 16:59'!
uiClass
	^DialogItemsChooserUI! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:27'!
unselectedItems

	^ unselectedItems! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/17/2010 02:27'!
unselectedItems: anObject

	unselectedItems := anObject! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 17:04'!
unselectedLabel
	^unselectedLabel! !

!DialogItemsChooser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/18/2010 17:04'!
unselectedLabel: anObject

	unselectedLabel := anObject! !
DialogItemsChooserUI initialize!
